This commit is contained in:
lounagen 2015-12-20 22:27:34 +00:00
Родитель 54a17becae
Коммит 753e118446
4 изменённых файлов: 192 добавлений и 1 удалений

176
kafka/files/systemv/kafka Normal file
Просмотреть файл

@ -0,0 +1,176 @@
#!/bin/sh
### BEGIN INIT INFO
# Provides: kafka
# Required-Start: $local_fs $network $remote_fs $syslog
# Required-Stop: $local_fs $network $remote_fs $syslog
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: kafka service
# Description: Manage kafka broker service
### END INIT INFO
# Author: lounagen <lounagen@gmail.com>
# Do NOT "set -e"
# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="kafka"
NAME=kafka
EXEC_NAME=kafka
EXEC_DAEMON=/usr/bin/java
EXEC_SUBSCRIPT_PATH=/usr/bin/java
DAEMON=/usr/local/lib/kafka/bin/kafka-server-start.sh
DAEMON_ARGS="-daemon /usr/local/lib/kafka/config/server.properties"
PIDFILE=/run/$EXEC_NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0
# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions
get_pid()
{
CURRENT_PID=$(ps ax | grep -i 'kafka\.Kafka' | grep java | grep -v grep | awk '{print $1}')
echo $CURRENT_PID
}
#
# Function that starts the daemon/service
#
do_start()
{
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
#start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
# || return 1
#start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
# $DAEMON_ARGS \
# || return 2
# The above code will not work for interpreted scripts, use the next
# six lines below instead (Ref: #643337, start-stop-daemon(8) )
start-stop-daemon --start --quiet --pidfile $PIDFILE --startas $DAEMON \
--name $EXEC_NAME --test > /dev/null \
|| return 1
start-stop-daemon --start --quiet --pidfile $PIDFILE --startas $DAEMON \
--name $EXEC_NAME -- $DAEMON_ARGS \
|| return 2
# Add code here, if necessary, that waits for the process to be ready
# to handle requests from services started subsequently which depend
# on this one. As a last resort, sleep for some time.
get_pid > $PIDFILE
}
#
# Function that stops the daemon/service
#
do_stop()
{
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
#start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --exec $EXEC_SUBSCRIPT_PATH
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently. A last resort is to
# sleep for some time.
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --pidfile $PIDFILE --exec $EXEC_SUBSCRIPT_PATH
[ "$?" = 2 ] && return 2
# Many daemons don't delete their pidfiles when they exit.
rm -f $PIDFILE
return "$RETVAL"
}
#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
#
# If the daemon can reload its configuration without
# restarting (for example, when it is sent a SIGHUP),
# then implement that here.
#
start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $EXEC_NAME
return 0
}
case "$1" in
start)
[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$EXEC_NAME"
do_start
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
stop)
[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$EXEC_NAME"
do_stop
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
status)
#status_of_proc "$DAEMON" "$EXEC_NAME" && exit 0 || exit $?
status_of_proc -p "$PIDFILE" "$EXEC_DAEMON" "$EXEC_NAME" && exit 0 || exit $?
;;
#reload|force-reload)
#
# If do_reload() is not implemented then leave this commented out
# and leave 'force-reload' as an alias for 'restart'.
#
#log_daemon_msg "Reloading $DESC" "$NAME"
#do_reload
#log_end_msg $?
#;;
restart|force-reload)
#
# If the "reload" option is implemented then remove the
# 'force-reload' alias
#
log_daemon_msg "Restarting $DESC" "$EXEC_NAME"
do_stop
case "$?" in
0|1)
do_start
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
*)
#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
exit 3
;;
esac
:

Просмотреть файл

@ -24,5 +24,5 @@ end script
chdir /usr/local/lib/kafka
script
/usr/local/lib/kafka/bin/kafka-server-start.sh /usr/local/lib/kafka/config/server.properties
/usr/local/lib/kafka/bin/kafka-server-start.sh -daemon /usr/local/lib/kafka/config/server.properties
end script

Просмотреть файл

@ -46,6 +46,15 @@ kafka-systemd:
- group: root
# todo: run "systemctl daemon-reload" after modifying the systemd files
kafka-systemv:
file.managed:
- name: /etc/init.d/kafka
- source: salt://kafka/files/systemv/kafka
- template: jinja
- mode: 755
- user: root
- group: root
kafka-upstart:
file.managed:
- name: /etc/init/kafka.conf

Просмотреть файл

@ -7,3 +7,9 @@ kafka-name:
service.running:
- name: {{ kafka.service.name }}
- enable: True
- watch:
- archive: kafka-tarball
- file: kafka-systemd
- file: kafka-systemv
- file: kafka-upstart